/* am930llc.c: Handles the Linux network interface
*	--------------------------------------------------------------------
*
*   Linux WLAN 
*
*   The contents of this file are subject to the Mozilla Public
*   License Version 1.0 (the "License"); you may not use this file
*   except in compliance with the License. You may obtain a copy of
*   the License at http://www.mozilla.org/MPL/
*
*   Software distributed under the License is distributed on an "AS
*   IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
*   implied. See the License for the specific language governing
*   rights and limitations under the License.
*
*   The initial developer of the original code is Mark S. Mathews
*   <mark@absoval.com>.  Portions created by Mark S. Mathews
*   are Copyright (C) 1998 AbsoluteValue Software, Inc.  All Rights Reserved.
*
*	--------------------------------------------------------------------
*/

#ifndef _LINUX_AM930LLC_H
#define _LINUX_AM930LLC_H

/*=============================================================*/
/*--- Constants -----------------------------------------------*/
/*=============================================================*/


/*=============================================================*/
/*--- Types ---------------------------------------------------*/
/*=============================================================*/

typedef struct device device_t;   /* see linux/netdevice.h */


typedef struct am930llc
{
	am930mac_t	*mac;
	am930mgr_t	*mgr;
	device_t	*dev;

	void 		*saveirq_fn;

} am930llc_t;


/*=============================================================*/
/*--- Methods -------------------------------------------------*/
/*=============================================================*/

am930llc_t *am930llc_construct(am930mac_t *mac, am930mgr_t *mgr);
void am930llc_destruct( am930llc_t *llc);

void am930llc_rxframe( am930llc_t *llc, UINT8 *frm, UINT32 len);
void am930llc_rxframe_err(am930llc_t *llc);
void am930llc_ontxcomplete( am930llc_t *llc, UINT32 txresult);

#define V2P(x) ((devpriv_t*)(x))


#ifdef PCMCIA_LLC_DEBUG
	#define AM930LLC_DB( DB_LEVEL, OUTLVL, FORMAT, A1) if ( DB_LEVEL <= pcmcia_llc_debug ) printk(OUTLVL __FILE__ ": " __FUNCTION__ ": " FORMAT, A1);
#else
	#define AM930LLC_DB( DB_LEVEL, OUTLVL, FORMAT, A1) 
#endif

#endif /* _LINUX_AM930LLC_H */

