/* wlan_compat.h: Types and macros to aid in portability
*	--------------------------------------------------------------------
*
*	Written 1997-99 by Mark Mathews   mark@absoval.com
*
*	Copyright (c) 1999 AbsoluteValue Software, Inc.
*	http://www.absoval.com
*
*	This software mayy be used and distributed according to the terms
*	of the GNU Public License, incoporated herein by reference.
*
*	The author may be reached as mark@absoval.com, or C/O AbsoluteValue
*	Software Inc., P.O. Box 941149, Maitland, FL, 32794-1149
*
*	--------------------------------------------------------------------
*/
#ifndef _WLAN_COMPAT_H
#define _WLAN_COMPAT_H

#define BIT0	0x00000001
#define BIT1	0x00000002
#define BIT2	0x00000004
#define BIT3	0x00000008
#define BIT4	0x00000010
#define BIT5	0x00000020
#define BIT6	0x00000040
#define BIT7	0x00000080
#define BIT8	0x00000100
#define BIT9	0x00000200
#define BIT10	0x00000400
#define BIT11	0x00000800
#define BIT12	0x00001000
#define BIT13	0x00002000
#define BIT14	0x00004000
#define BIT15	0x00008000
#define BIT16	0x00010000
#define BIT17	0x00020000
#define BIT18	0x00040000
#define BIT19	0x00080000
#define BIT20	0x00100000
#define BIT21	0x00200000
#define BIT22	0x00400000
#define BIT23	0x00800000
#define BIT24	0x01000000
#define BIT25	0x02000000
#define BIT26	0x04000000
#define BIT27	0x08000000
#define BIT28	0x10000000
#define BIT29	0x20000000
#define BIT30	0x40000000
#define BIT31	0x80000000

#define MOTO_BIT31	0x00000001
#define MOTO_BIT30	0x00000002
#define MOTO_BIT29	0x00000004
#define MOTO_BIT28	0x00000008
#define MOTO_BIT27	0x00000010
#define MOTO_BIT26	0x00000020
#define MOTO_BIT25	0x00000040
#define MOTO_BIT24	0x00000080
#define MOTO_BIT23	0x00000100
#define MOTO_BIT22	0x00000200
#define MOTO_BIT21	0x00000400
#define MOTO_BIT20	0x00000800
#define MOTO_BIT19	0x00001000
#define MOTO_BIT18	0x00002000
#define MOTO_BIT17	0x00004000
#define MOTO_BIT16	0x00008000
#define MOTO_BIT15	0x00010000
#define MOTO_BIT14	0x00020000
#define MOTO_BIT13	0x00040000
#define MOTO_BIT12	0x00080000
#define MOTO_BIT11	0x00100000
#define MOTO_BIT10	0x00200000
#define MOTO_BIT9	0x00400000
#define MOTO_BIT8	0x00800000
#define MOTO_BIT7	0x01000000
#define MOTO_BIT6	0x02000000
#define MOTO_BIT5	0x04000000
#define MOTO_BIT4	0x08000000
#define MOTO_BIT3	0x10000000
#define MOTO_BIT2	0x20000000
#define MOTO_BIT1	0x40000000
#define MOTO_BIT0	0x80000000

typedef unsigned char   UINT8;
typedef unsigned short  UINT16;
typedef unsigned long   UINT32;

typedef signed char     INT8;
typedef signed short    INT16;
typedef signed long     INT32;

typedef unsigned int    UINT;
typedef signed int      INT;

#ifdef __GNUC__
typedef unsigned long long	UINT64;
typedef signed long long	INT64;
#endif

typedef UINT8			UINT48[6];  /* for dealing w/ ether addr */

/* Debug levels */
#define DBL_LOG		1
#define DBL_FUNC	2
#define DBL_MEMBER	3
#define DBL_LOCAL	4

/*=============================================================*/
/*------ Compiler Portability Macros --------------------------*/
/*=============================================================*/
#ifdef __GNUC__
	#ifndef __GNUC_PACK__
		#define __GNUC_PACK__	__attribute__ ((packed))
	#endif

	#ifndef __GNUC_INLINE__
		#define __GNUC_INLINE__ inline
	#endif
#else
	#ifndef __GNUC_PACK__
		#define __GNUC_PACK__
	#endif

	#ifndef __GNUC_INLINE__
		#define __GNUC_INLINE__ 
	#endif
#endif


/*=============================================================*/
/*------ OS Portability Macros --------------------------------*/
/*=============================================================*/
#ifdef LINUX_VERSION_CODE
#define __LINUX_KERNEL__
#endif

#ifdef __LINUX_KERNEL__
	#define WLAN_ASSERT(c)
	#define WLAN_FRAME_DUMP( p, n)	
	#define WLAN_LOG_WARNING0(s) printk(KERN_WARNING __FUNCTION__": " s);
	#define WLAN_LOG_WARNING1(s,n) printk(KERN_WARNING __FUNCTION__": " s, (n));
	#define WLAN_LOG_WARNING2(s,n1,n2) printk(KERN_WARNING __FUNCTION__": " s, (n1), (n2));
	#define WLAN_LOG_WARNING3(s,n1,n2,n3) printk(KERN_WARNING __FUNCTION__": " s, (n1), (n2), (n3));
	#define WLAN_LOG_WARNING4(s,n1,n2,n3,n4) printk(KERN_WARNING __FUNCTION__": " s, (n1), (n2), (n3), (n4));
	#define WLAN_LOG_ERROR0(s) printk(KERN_ERR __FUNCTION__": " s);
	#define WLAN_LOG_ERROR1(s,n) printk(KERN_ERR __FUNCTION__": " s, (n));
	#define WLAN_LOG_ERROR2(s,n1,n2)printk(KERN_ERR __FUNCTION__": " s, (n1), (n2));
	#define WLAN_LOG_ERROR3(s,n1,n2,n3) printk(KERN_ERR __FUNCTION__": " s, (n1), (n2), (n3));
	#define WLAN_LOG_ERROR4(s,n1,n2,n3,n4) printk(KERN_ERR __FUNCTION__": " s, (n1), (n2), (n3), (n4));
	#define WLAN_LOG_NOTICE0(s) printk(KERN_NOTICE __FUNCTION__": " s);
	#define WLAN_LOG_NOTICE1(s,n) printk(KERN_NOTICE __FUNCTION__": " s, (n));
	#define WLAN_LOG_NOTICE2(s,n1,n2)printk(KERN_NOTICE __FUNCTION__": " s, (n1), (n2));
	#define WLAN_LOG_NOTICE3(s,n1,n2,n3) printk(KERN_NOTICE __FUNCTION__": " s, (n1), (n2), (n3));
	#define WLAN_LOG_NOTICE4(s,n1,n2,n3,n4) printk(KERN_NOTICE __FUNCTION__": " s, (n1), (n2), (n3), (n4));
#else
	#define WLAN_ASSERT(c)
	#define WLAN_FRAME_DUMP(p, n)	
	#define WLAN_LOG_WARNING0(s)
	#define WLAN_LOG_WARNING1(s,n)
	#define WLAN_LOG_WARNING2(s,n1,n2)
	#define WLAN_LOG_WARNING3(s,n1,n2,n3)
	#define WLAN_LOG_WARNING4(s,n1,n2,n3,n4)
	#define WLAN_LOG_ERROR0(s)
	#define WLAN_LOG_ERROR1(s,n)
	#define WLAN_LOG_ERROR2(s,n1,n2)
	#define WLAN_LOG_ERROR3(s,n1,n2,n3)
	#define WLAN_LOG_ERROR4(s,n1,n2,n3,n4)
#endif

/*=============================================================*/
/*------ Hardware Portability Macros --------------------------*/
/*=============================================================*/

#if defined(__i386__)
	#define ieee2host16(n)	(n)
	#define ieee2host32(n)	(n)
	#define host2ieee16(n)	(n)
	#define host2ieee32(n)	(n)
#elif defined(CONFIG_PPC)
	#define ieee2host16(n)	(__swab16((n)))
	#define ieee2host32(n)	(__swab32((n)))
	#define host2ieee16(n)	(__swab16((n)))
	#define host2ieee32(n)	(__swab32((n)))
#endif

/*=============================================================*/
/*--- Functions -----------------------------------------------*/
/*=============================================================*/

#endif /*  _WLAN_PORT_H */

